<?php

/*
 *  Copyright 2003-2033 dahantc.com Inc.All Rights Reserved.
 *
 *	【使用前必读说明！】
 *  此类为PHP对Redis进行简单读写的操作类，使用时必须保证：
 *	1.Redis服务已安装并正常运行
 *  2.Redis服务允许被访问
 *  3.PHP支持并开启Redis配置
 
 *  如果您在接入过程中，碰到任何技术问题，请随时联系大汉云通讯的客服和技术支持寻求帮助！官网地址：http://www.dahancloud.com
 */

class RedisManager {
	
	private $host = '127.0.0.1'; // redis服务地址
	private $port = 6379;  		 // redis服务端口
	private $redis;				 // redis实例
	private $expireTime = 3*60;  // 缓存过期时间，以秒单位，默认3分钟失效
	
	function __construct() {
		$this->redis = new Redis();
		$this->redis->connect($this->host, $this->port);
	}
	
	// 存入成功，返回true；否则返回false
	public function setValue($inKey, $inValue) {
		return $this->redis->setex($inKey, $this->expireTime, $inValue);
	}
	
	// 根据key读取值，如果读取失败或为NULL，返回空字符串
	public function getValue($inKey) {
		$result = $this->redis->get($inKey);
		
		if (!$result || $result == NULL) {
			$result = '';
		}
		
		return $result;
	}
	
	// 删除某个key，验证码如果使用完成之后或需要强制删除，需要删除请调用此方法；
	// 如果不调用此方法，redis中对应的键值到期也会自动删除
	public function deleteValue($inKey) {
		$this->redis->del($inKey);
	}
	
	function __destruct() {
		$this->redis->close();
	}
	
}
	
?>